//
// Created by postaron on 31/07/24.
//

#include "problem_4.hpp"
#include "../common/common_functions.hpp"

#include <vector>
#include <set>
#include <string>
#include <cmath>
#include <algorithm>
#include <numeric>

std::vector<int> extract_unique_cards(const std::string &input) {
    std::set<int> unique_part;

    bool begin_num = false;
    std::string tmp_num;
    for (const auto &item: input) {
        if (!begin_num && item != ' ') {
            begin_num = true;
            tmp_num.push_back(item);
        } else if (begin_num && item == ' ') {
            begin_num = false;
            unique_part.insert(std::stoi(tmp_num));
            tmp_num.clear();
        } else if (begin_num) {
            tmp_num.push_back(item);
        }
    }
    if (!tmp_num.empty()) {
        unique_part.insert(std::stoi(tmp_num));
    }

    return { unique_part.cbegin(), unique_part.cend() };
}

std::size_t pb4::problem_part1(const std::filesystem::path &problemFile) noexcept {
    auto file_opt = common::read_file(problemFile);
    if (!file_opt) {
        return 0;
    }
    std::ifstream &file = *file_opt;
    std::string line;
    std::vector<int> compute_points;
    while (std::getline(file, line)) {
        if (!line.empty()) {
            line = line.substr(line.find_first_of(':') + 1);

            const auto split_char = line.find_first_of('|');
            const auto left = line.substr(0, split_char);
            const auto right = line.substr(split_char + 1);

            const auto left_cards = extract_unique_cards(left);
            const auto right_cards = extract_unique_cards(right);
            std::vector<int> intersection;
            intersection.reserve(left.size() + right_cards.size());
            std::set_intersection(left_cards.cbegin(),
                    left_cards.cend(),
                    right_cards.cbegin(),
                    right_cards.cend(),
                    std::back_inserter(intersection));
            if (!intersection.empty()) {
                compute_points.emplace_back(
                        static_cast<int>(std::floor(std::pow(2.0f, static_cast<float>(intersection.size() - 1))))
                );
            } else {
                compute_points.emplace_back(0);
            }
        }
    }
    return std::accumulate(compute_points.cbegin(), compute_points.cend(), 0);
}
